/*
Copyright (C) 2009 -  Claudio Salvadori
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// generated by Fast Light User Interface Designer (fluid) version 1.0108

#include "demo.h"
#include <pthread.h>
#include "mySerial.h"
#include "myUtils.h"
#include <Fl/Fl_Image.H>
#define BUFF_SIZE 19200
static pthread_t capture; 
static My_Serial com; 
static const char* port_name; 
static unsigned int baud_rate=0; 
static Fl_RGB_Image *m_image; 
static int r; //Resolution value

Fl_Double_Window *Demo=(Fl_Double_Window *)0;

Fl_Box *m_box=(Fl_Box *)0;

Fl_Button *m_start=(Fl_Button *)0;

Fl_Button *m_init=(Fl_Button *)0;

Fl_Dial *m_quality=(Fl_Dial *)0;

Fl_Dial *m_time=(Fl_Dial *)0;

static Fl_Value_Output *m_time_v=(Fl_Value_Output *)0;

Fl_Dial *m_resolution=(Fl_Dial *)0;

Fl_Button *time_send=(Fl_Button *)0;

Fl_Button *res_send=(Fl_Button *)0;

Fl_Button *wnd_send=(Fl_Button *)0;

Fl_Value_Input *m_width=(Fl_Value_Input *)0;

Fl_Value_Input *m_height=(Fl_Value_Input *)0;

Fl_Value_Input *m_x=(Fl_Value_Input *)0;

Fl_Value_Input *m_y=(Fl_Value_Input *)0;

Fl_Button *send_v_h=(Fl_Button *)0;

Fl_Value_Input *hblank=(Fl_Value_Input *)0;

Fl_Value_Input *vblank=(Fl_Value_Input *)0;

Fl_Value_Output *m_image_n=(Fl_Value_Output *)0;

Fl_Value_Output *m_lum=(Fl_Value_Output *)0;

Fl_Value_Output *m_width_res=(Fl_Value_Output *)0;

Fl_Value_Output *m_f_r=(Fl_Value_Output *)0;

Fl_Value_Output *m_height_res=(Fl_Value_Output *)0;

Fl_Value_Output *m_lost=(Fl_Value_Output *)0;

static Fl_Value_Output *m_res_v=(Fl_Value_Output *)0;

static Fl_Value_Output *m_q_v=(Fl_Value_Output *)0;

Fl_Spinner *m_com=(Fl_Spinner *)0;

Fl_Value_Input *m_baud=(Fl_Value_Input *)0;

Fl_Check_Button *m_send=(Fl_Check_Button *)0;

Fl_Button *m_sleep=(Fl_Button *)0;

Fl_Button *m_active=(Fl_Button *)0;

Fl_Input *m_value=(Fl_Input *)0;

Fl_Button *b_reg=(Fl_Button *)0;

Fl_Input *m_reg=(Fl_Input *)0;

int main(int argc, char **argv) {
	Fl::visual(FL_RGB);
	 /*Fluid code autogeneration*/
	 { // Fl_Double_Window* Demo
		Demo = new Fl_Double_Window(549, 578, "Demo for HV7131GP");
		Demo->box(FL_BORDER_BOX);
		{ // Fl_Box* m_box
			//Attention!! m_box has to have only this setting!!!
			m_box = new Fl_Box(15, 15, 160, 120);
		    m_box->box(FL_FLAT_BOX);
		} 
		
	    { // Fl_Button* m_start
			m_start = new Fl_Button(20, 235, 160, 30, "Start comm");
	        m_start->down_box(FL_UP_BOX);
	        m_start->labeltype(FL_ENGRAVED_LABEL);
	        m_start->callback((Fl_Callback*)start_cb);
	    } 
		
	    { // Fl_Button* m_init
			m_init = new Fl_Button(390, 25, 105, 35, "Init conf");
			m_init->labeltype(FL_ENGRAVED_LABEL);
			m_init->callback((Fl_Callback*)init_cb);
			m_init->deactivate();
	    } 
		
	    { // Fl_Dial* m_quality
			m_quality = new Fl_Dial(195, 5, 80, 80, "Quality value");
			m_quality->maximum(2);
		    m_quality->step(1);
		    m_quality->callback((Fl_Callback*)write_value_cb, (void*)("Quality"));
		    m_quality->deactivate();
	    }
		
	    { // Fl_Dial* m_time
			m_time = new Fl_Dial(195, 106, 80, 78, "Time divisor");
			m_time->maximum(7);
			m_time->step(1);
			m_time->callback((Fl_Callback*)write_value_cb, (void*)("Time"));
			m_time->deactivate();
	    } 
		
	    { // Fl_Value_Output* m_time_v
			m_time_v = new Fl_Value_Output(294, 140, 75, 25, "Time divisor");
			m_time_v->align(FL_ALIGN_TOP_LEFT);
			m_time_v->deactivate();
	    } 
	    { // Fl_Dial* m_resolution
			m_resolution = new Fl_Dial(195, 210, 80, 80, "Resolution");
			m_resolution->maximum(2);
			m_resolution->step(1);
			m_resolution->callback((Fl_Callback*)write_value_cb, (void*)("Res"));
			m_resolution->deactivate();
	    } 
	    { // Fl_Button* time_send
			time_send = new Fl_Button(390, 125, 105, 35, "Send time div.");
			time_send->labeltype(FL_SHADOW_LABEL);
			time_send->callback((Fl_Callback*)time_cb);
			time_send->deactivate();
	    } 
		
	    { // Fl_Button* res_send
			res_send = new Fl_Button(390, 215, 105, 35, "Send resolution");
			res_send->labeltype(FL_SHADOW_LABEL);
			res_send->callback((Fl_Callback*)res_cb);
			res_send->deactivate();
	    } 
		
	    { // Fl_Group* o
			Fl_Group* o = new Fl_Group(290, 285, 220, 150, "Window");
			o->box(FL_ROUNDED_BOX);
			{// Fl_Button* wnd_send 
				wnd_send = new Fl_Button(420, 340, 70, 40, "Send data");
				wnd_send->callback((Fl_Callback*)data_cb);
				wnd_send->deactivate();
			} 
			
			{ // Fl_Value_Input* m_width
				m_width = new Fl_Value_Input(345, 305, 70, 25, "Width");
				m_width->maximum(640);
				m_width->value(640);
				m_width->deactivate();
			} 
			
			{ // Fl_Value_Input* m_height
				m_height = new Fl_Value_Input(345, 335, 70, 25, "Height");
				m_height->maximum(480);
				m_height->value(480);
				m_height->deactivate();
			} 
			
			{ // Fl_Value_Input* m_x
				m_x = new Fl_Value_Input(345, 365, 70, 25, "X");
				m_x->minimum(2);
				m_x->maximum(640);
				m_x->value(2);
				m_x->deactivate();
			} 
			
			{ // Fl_Value_Input* m_y
				m_y = new Fl_Value_Input(345, 400, 70, 25, "Y");
				m_y->minimum(2);
				m_y->maximum(480);
				m_y->value(2);
				m_y->deactivate();
			} 
			o->end();
		} 
		
	    { // Fl_Group* o
			Fl_Group* o = new Fl_Group(290, 465, 215, 90, "HBLANK vs VBLANK");
			o->box(FL_BORDER_BOX);
			{ // Fl_Button* send_v_h
				send_v_h = new Fl_Button(425, 480, 70, 60, "Send");
				send_v_h->callback((Fl_Callback*)h_v_cb);
				send_v_h->deactivate();
			} 
			{ // Fl_Value_Input* hblank
				hblank = new Fl_Value_Input(355, 480, 65, 25, "HBLANK");
				hblank->value(208);
				hblank->deactivate();
			} 
			{ // Fl_Value_Input* vblank
				vblank = new Fl_Value_Input(355, 515, 65, 25, "VBLANK");
				vblank->value(8);
				vblank->deactivate();
			} 
			o->end();
	    } 
		
	    { // Fl_Group* o
			Fl_Group* o = new Fl_Group(15, 330, 255, 110, "Results");
			o->box(FL_BORDER_BOX);
			{ // Fl_Value_Output* m_image_n
				m_image_n = new Fl_Value_Output(70, 335, 70, 20, "Image n");
				m_image_n->deactivate();
			} 
			
			{ // Fl_Value_Output* m_lum
				m_lum = new Fl_Value_Output(185, 335, 80, 25, "Y");
				m_lum->deactivate();
			} 
			
			{ // Fl_Value_Output* m_width_res
				m_width_res = new Fl_Value_Output(60, 365, 80, 25, "Width");
				m_width_res->deactivate();
			} 
			
			{ // Fl_Value_Output* m_f_r
				m_f_r = new Fl_Value_Output(185, 370, 80, 25, "F.r.");
				m_f_r->deactivate();
			} 
			
			{ // Fl_Value_Output* m_height_res
				m_height_res = new Fl_Value_Output(60, 400, 80, 25, "Height");
				m_height_res->deactivate();
			} 
			
			{ // Fl_Value_Output* m_lost
				m_lost = new Fl_Value_Output(185, 405, 80, 25, "Lost");
				m_lost->deactivate();
			} 
	      o->end();
	    } 
		
	    { // Fl_Value_Output* m_res_v
			m_res_v = new Fl_Value_Output(295, 230, 75, 25, "Res value");
			m_res_v->align(FL_ALIGN_TOP_LEFT);
			m_res_v->deactivate();
	    } 
		
	    { // Fl_Value_Output* m_q_v
			m_q_v = new Fl_Value_Output(295, 35, 75, 25, "Qual value");
			m_q_v->align(FL_ALIGN_TOP_LEFT);
			m_q_v->deactivate();
	    } 
		
	    { // Fl_Spinner* m_com
			m_com = new Fl_Spinner(55, 190, 120, 25, "COM:");
		    m_com->maximum(9);
			m_com->value(2);
	    } 
		
	    { // Fl_Value_Input* m_baud
			m_baud = new Fl_Value_Input(15, 155, 160, 25, "Buad rate");
			m_baud->align(FL_ALIGN_TOP_LEFT);
	    } 
		
	    { // Fl_Check_Button* m_send
			m_send = new Fl_Check_Button(310, 70, 160, 30, "Send picture");
			m_send->down_box(FL_DOWN_BOX);
			m_send->value(1);
			m_send->deactivate();
	    } 
		
	    { // Fl_Button* m_sleep
			m_sleep = new Fl_Button(20, 275, 65, 30, "Sleep");
			m_sleep->callback((Fl_Callback*)sleep_cb);
			m_sleep->deactivate();
	    } 
		
	    { // Fl_Button* m_active
			m_active = new Fl_Button(115, 275, 65, 30, "Active");
			m_active->callback((Fl_Callback*)active_cb);
			m_active->deactivate();
	    } 
		
	    { // Fl_Group* o
			Fl_Group* o = new Fl_Group(15, 450, 255, 100, "Set Register");
			o->box(FL_BORDER_BOX);
			o->align(FL_ALIGN_TOP|FL_ALIGN_INSIDE);
			{ // Fl_Input* m_value
				m_value = new Fl_Input(80, 510, 80, 25, "Value");
				m_value->deactivate();
			} 
			
			{ // Fl_Button* b_reg 
				b_reg = new Fl_Button(170, 510, 80, 25, "Set reg");
				b_reg->callback((Fl_Callback*)set_reg_cb);
				b_reg->deactivate();
			} 
			
			{ // Fl_Input* m_reg
				m_reg = new Fl_Input(100, 475, 145, 25, "Register");
				m_reg->deactivate();
			} 
	      o->end();
	    } 
	    Demo->end();
	} 
	
	//Com preset
	switch ((int) m_com->value()) {
		case 1:
			port_name = "com1";
			break;
		
		case 2:
			port_name = "com2";
			break;
		
		case 3:
			port_name = "com3";
			break;
		
		case 4:
			port_name = "com4";
			break;
		
		case 5:
			port_name = "com5";
			break;
		
		case 6:
			port_name = "com6";
			break;
		
		case 7:
			port_name = "com7";
			break;
		
		case 8:
			port_name = "com8";
			break;
		
		case 9:
			port_name = "com9";
			break;
	}
	
	//Baud-rate preset
	baud_rate = (const int) m_baud->value();
	Demo->show(argc, argv);
	return Fl::run();
}

//Dials callback function
void write_value_cb(Fl_Widget *, void* userdata) {
  if((const char*) userdata == "Time")
		m_time_v->value(m_time->value());

	if((const char*) userdata == "Res")
		m_res_v->value(m_resolution->value());

	if((const char*) userdata == "Quality")
		m_q_v->value(m_quality->value());
}

//Callback function: start communication via RS232 with Flex
void start_cb(Fl_Widget *, void* userdata) {
	const unsigned char c = 0x31;
	int ret;
	unsigned char answer = 0x00;
	
	//Com set
	switch ((int) m_com->value()) {
		case 1:
			port_name = "com1";
			break;
		
		case 2:
			port_name = "com2";
			break;
		
		case 3:
			port_name = "com3";
			break;
		
		case 4:
			port_name = "com4";
			break;
		
		case 5:
			port_name = "com5";
			break;
		
		case 6:
			port_name = "com6";
			break;
		
		case 7:
			port_name = "com7";
			break;
		
		case 8:
			port_name = "com8";
			break;
		
		case 9:
			port_name = "com9";
			break;
	}
	//Set baud-rate	
	baud_rate = (const int) m_baud->value();
	
	if (!my_Serial_init(&com, port_name, baud_rate)) {
		printf("ERROR : Serial init %s \n", port_name);
		exit(EXIT_FAILURE);
	}
	
	//Send start message
	ret = my_Serial_putc(&com, (char)c);

	if (ret < 0 ) {
		printf("ERROR : Serial Put Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) {

		printf("ERROR : Serial Transmit Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

	//Receive answer
	ret = my_Serial_read(&com, (char*)&answer, 1);
	
	if (ret < 0 ) {

		printf("ERROR : Serial Get Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) {
		printf("ERROR : Serial Receive Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
	if (answer != 0x31) {  // 0x31 = Ack
		printf("ERROR : Bad Serial Answer \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
	//...some cativation/deactivation
	m_init->activate();
	m_quality->activate();
	m_send->activate();
	m_start->deactivate();
}

//Callback function: send preset
void init_cb(Fl_Widget *, void* userdata) {
	int ret;
	unsigned char answer = 0x00;
	unsigned char msg[7];
	
	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x00;
	msg[2] = 0x30 + (int)m_q_v->value();
	msg[3] = 0x2A;
	msg[4] = 0x00;
	msg[5] = 0x30+ (int)m_send->value();
	msg[6] = 0x2A;
	
	//Setting the serial timeout based on the time divisor
	switch((int)m_q_v->value())
	{
		case 0:
		my_Serial_set_timeout(&com, 1);
		break;
		
		case 1:
		my_Serial_set_timeout(&com, 3);
		break;
		
		case 2:
		default:
		my_Serial_set_timeout(&com, 6);
		break;
	}
	
	//Send message
	ret = my_Serial_write(&com, (char*)&msg, 7);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
	//Receive answer
	ret = my_Serial_read(&com, (char*)&answer, 1);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial Get Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{ 
		printf("ERROR : Serial Receive Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
	if (answer != 0x31) // 0x31 = Ack
	{
		printf("ERROR : Bad Serial Answer \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
	//Success!! Enable stuff... Disable init button and related stuff
	m_time->activate();
	time_send->activate();
	m_resolution->activate();
	res_send->activate();
	wnd_send->activate();
	m_width->activate();
	m_height->activate();
	m_x->activate();
	m_y->activate();
	m_sleep->activate();
	m_active->activate();
	hblank->activate();
	vblank->activate();
	send_v_h->activate();
	m_reg->activate();
	b_reg->activate();
	m_value->activate();
	m_quality->deactivate();
	m_init->deactivate();
	m_send->deactivate();
	
	m_reg->maximum_size(2);
	m_value->maximum_size(2);
	
	//Resolution value to set camera in safe mode
	r = 4;
	
	//Start capture in multithreadind
	ret = pthread_create( &capture, NULL, &serial_capture, NULL);
}

//Thead "capture" body: this thread receive via RS232 data and image from flex
void* serial_capture(void*) {
	unsigned long long count=0;
	unsigned char buff1[BUFF_SIZE];
	unsigned int msg_idx;
	int w,h, ret, y, l;
	float fr;
	
	m_image_n->value(count);
	
	while (1) {
	
		count++;
	
		memset(buff1, 0, BUFF_SIZE);
		
		//Receive header and debug data
		ret = my_Serial_read(&com, (char*)&buff1, 15);

		if (ret < 0 ) {
			printf("ERROR : Serial Get Char\n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		if (ret == 0) {
			printf("ERROR : Serial Receive Timeout\n");
			pthread_exit(NULL);
		}

		if (buff1[0]==0xAA && buff1[1]==0xBB) {
			msg_idx = 3;
			//Width
			w =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			w += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;
			
			//Height
			h =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			h += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;
		
			//Frame duration
			fr =  (((unsigned int)buff1[msg_idx++])  << 24 ) & 0xFF000000;
			fr += (((unsigned int)buff1[msg_idx++])  << 16 ) & 0x00FF0000;
			fr +=  (((unsigned int)buff1[msg_idx++]) << 8  ) & 0x0000FF00;
			fr += (((unsigned int)buff1[msg_idx++])        ) & 0x000000FF;	
			
			//Frame rate
			fr = (unsigned int) 40000000 / fr;
			
			//Frame lost?
			l =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			l += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;
			
			//Luminace mean value
			y =  (((unsigned int)buff1[msg_idx++]) << 8 ) & 0x0000FF00;
			y += (((unsigned int)buff1[msg_idx++])      ) & 0x000000FF;			
		} else {
			printf("ERROR : Bad Header Received\n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		//Write the value in the right field
		m_image_n->value(count);	//Image received #
		m_width_res->value(w);		//Width
		m_height_res->value(h); 	//Height
		m_f_r->value(fr);			//Frame rate
		m_lost->value(l);			//Frame lost?
		m_lum->value(y);			//Y mean value	
		
		if(m_send)
		{
			//Resize the image box
			m_box->size(w,h);
		
			memset(buff1, 0, BUFF_SIZE);
			
			//Receive raw frame
			ret = my_Serial_read(&com, (char*)&buff1, w*h);
				
			if (ret < 0 ) {
				printf("ERROR : Serial Put Char\n");
				my_Serial_close(&com);
				exit(EXIT_FAILURE);
			}

					
			if (ret == 0) {

				printf("ERROR : Serial Transmit Timeout\n");;
				pthread_exit(NULL);
			}
			
			fflush(stdout);
		
			if(!image_show(buff1, w, h, 1)){
				printf("ERROR : Image Show\n");
				my_Serial_close(&com);
				exit(EXIT_FAILURE);
			}

			Fl::check();
		}
	}
}

//Function called to show image in box
bool image_show(unsigned char *image, unsigned int w, unsigned int h, unsigned int channel) {
	if(channel !=1 && channel !=3)
		return false;

	if(m_image) delete m_image;

	m_image = new Fl_RGB_Image(image, w, h,channel);
	m_box->image(m_image);
	m_box->redraw();

	return true;
}

//Callback function: send time divisor pkt via rs232
void time_cb(Fl_Widget *, void* userdata) {
	unsigned char msg[15];
	int ret;
	
	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x54; //T
	msg[2] = 0x2A;
	msg[3] = 0x30;
	msg[4] = 0x30+ m_time_v->value();
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;
	
	//Setting the serial timeout based on the time divisor
	switch((int)m_time_v->value())
	{
		case 0:
		my_Serial_set_timeout(&com, 0);
		break;
		
		case 1:
		my_Serial_set_timeout(&com, 1);
		break;
		
		case 2:
		my_Serial_set_timeout(&com, 2);
		break;
		
		case 3:
		my_Serial_set_timeout(&com, 3);
		break;
		
		case 4:
		my_Serial_set_timeout(&com, 4);
		break;
		
		case 5:
		my_Serial_set_timeout(&com, 5);
		break;
		
		case 6:
		my_Serial_set_timeout(&com, 6);
		break;
		
		case 7:
		default:
		my_Serial_set_timeout(&com, 7);
		break;
	}
	
	//send pkt
	ret = my_Serial_write(&com, (char*)&msg, 15);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
}

//Callback function: send resolution pkt via rs232
void res_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
	int ret;
	int size_t;
	
	size_t = (int)m_width->value() * (int)m_height->value() / (m_resolution->value() * m_resolution->value() * 4);
	
	if(size_t <= 19200){
	
		//prepare message to send
		msg[0] = 0x2A;
		msg[1] = 0x52; //R
		msg[2] = 0x2A;
		msg[3] = 0x30;
		msg[4] = 0x30+ m_resolution->value();
		msg[5] = 0x2A;
		msg[6] = 0x2A;
		msg[7] = 0x2A;
		msg[8] = 0x2A;
		msg[9] = 0x2A;
		msg[10] = 0x2A;
		msg[11] = 0x2A;
		msg[12] = 0x2A;
		msg[13] = 0x2A;
		msg[14] = 0x2A;
		
		//send pkt
		ret = my_Serial_write(&com, (char*)&msg, 15);
		
		if (ret < 0 ) 
		{
			printf("ERROR : Serial io Char \n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		if (ret == 0) 
		{
			printf("ERROR : Serial io Timeout \n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		
		//Set the sent resolution value
		r = m_resolution->value() * 2;
		
	} else printf("Pkt isn't sent... Buffer bigger than 19200 pixel");
}

//Callback function: send window data pkt via rs232
void data_cb(Fl_Widget *, void* userdata) {
	unsigned char msg[15];
	int ret;
	int size_t;
	
	size_t = (int)m_width->value() * (int)m_height->value() / (r * r);
	
	if(size_t <= 19200){
		//prepare message to send
		msg[0] = 0x2A;
		msg[1] = 0x44; //H
		msg[2] = 0x2A;
		msg[3] = ((int)m_width->value() >> 8) & 0x00FF;
		msg[4] = ((int)m_width->value() 	) & 0x00FF;
		msg[5] = 0x2A;
		msg[6] = ((int)m_height->value() >> 8) & 0x00FF;
		msg[7] = ((int)m_height->value()     ) & 0x00FF;
		msg[8] = 0x2A;
		msg[9] = ((int)m_x->value() >> 8) & 0x00FF;
		msg[10] =((int)m_x->value()     ) & 0x00FF;
		msg[11] = 0x2A;
		msg[12] = ((int)m_y->value() >> 8) & 0x00FF;
		msg[13] = ((int)m_y->value()     ) & 0x00FF;
		msg[14] = 0x2B;
		
		ret = my_Serial_write(&com, (char*)&msg, 15);
		
		if (ret < 0 ) 
		{
			printf("ERROR : Serial io Char \n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
		if (ret == 0) 
		{
			printf("ERROR : Serial io Timeout \n");
			my_Serial_close(&com);
			exit(EXIT_FAILURE);
		}
	} else printf("Pkt isn't sent... Buffer bigger than 19200 pixel");
}

//Callback function: send vblank/hblank value pkt via rs232
void h_v_cb(Fl_Widget *, void* userdata) {
	unsigned char msg[15];
	int ret;
	
	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x48; //H
	msg[2] = 0x2A;
	msg[3] = ((int)hblank->value() >> 8) & 0x00FF;
	msg[4] = ((int)hblank->value() 	   ) & 0x00FF;
	msg[5] = 0x2A;
	msg[6] = ((int)vblank->value() >> 8) & 0x00FF;
	msg[7] = ((int)vblank->value() 	   ) & 0x00FF;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;
	
	ret = my_Serial_write(&com, (char*)&msg, 15);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}

}

//Callback function: send register pkt via rs232
void set_reg_cb(Fl_Widget *, void* userdata) {
	unsigned char msg[15];
	int ret;
	char r1, r2, v1, v2;
	
	if((m_reg->index(0) >= 0x30) && (m_reg->index(0) <= 0x39))
		r1 = m_reg->index(0);
	else {
		if((m_reg->index(0) >= 0x41) && (m_reg->index(0) <= 0x46))
			r1 = m_reg->index(0);
		else {
			if((m_reg->index(0) >= 0x61) && (m_reg->index(0) <= 0x66))
				r1 = m_reg->index(0) - 0x20;
			else {
				printf("Register value is not correct");
				return;
			}
		
		}
	}
	
	if((m_reg->index(1) >= 0x30) && (m_reg->index(1) <= 0x39))
		r2 = m_reg->index(1);
	else {
		if((m_reg->index(1) >= 0x41) && (m_reg->index(1) <= 0x46))
			r2 = m_reg->index(1);
		else {
			if((m_reg->index(1) >= 0x61) && (m_reg->index(1) <= 0x66))
				r2 = m_reg->index(1) - 0x20;
			else {
				printf("Register value is not correct");
				return;
			}
		
		}
	}
	
	if((m_value->index(0) >= 0x30) && (m_value->index(0) <= 0x39))
		v1 = m_value->index(0);
	else {
		if((m_value->index(0) >= 0x41) && (m_value->index(0) <= 0x46))
			v1 = m_value->index(0);
		else {
			if((m_value->index(0) >= 0x61) && (m_value->index(0) <= 0x66))
				v1 = m_value->index(0) - 0x20;
			else {
				printf("Value is not correct");
				return;
			}
		
		}
	}
	
	if((m_value->index(1) >= 0x30) && (m_value->index(1) <= 0x39))
		v2 = m_value->index(1);
	else {
		if((m_value->index(1) >= 0x41) && (m_value->index(1) <= 0x46))
			v2 = m_value->index(1);
		else {
			if((m_value->index(1) >= 0x61) && (m_value->index(1) <= 0x66))
				v2 = m_value->index(1) - 0x20;
			else {
				printf("Value is not correct");
				return;
			}
		
		}
	}
	
	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x31; //1
	msg[2] = 0x2A;
	msg[3] = r1;
	msg[4] = r2;
	msg[5] = 0x2A;
	msg[6] = v1;
	msg[7] = v2;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;
	
	ret = my_Serial_write(&com, (char*)&msg, 15);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
}

//Callback function: send sleep pkt via rs232
void sleep_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
int ret;
	
	//Set fastest timeout
	my_Serial_set_timeout(&com, 0);
	
	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x53; //S
	msg[2] = 0x2A; 
	msg[3] = 0x2A; 
	msg[4] = 0x2A;
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;
	
	ret = my_Serial_write(&com, (char*)&msg, 15);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
}

//Callback function: send activation pkt via rs232
void active_cb(Fl_Widget *, void* userdata) {
  unsigned char msg[15];
int ret;
	
	//prepare message to send
	msg[0] = 0x2A;
	msg[1] = 0x41; //A
	msg[2] = 0x2A; //C
	msg[3] = 0x2A; //T
	msg[4] = 0x2A;
	msg[5] = 0x2A;
	msg[6] = 0x2A;
	msg[7] = 0x2A;
	msg[8] = 0x2A;
	msg[9] = 0x2A;
	msg[10] = 0x2A;
	msg[11] = 0x2A;
	msg[12] = 0x2A;
	msg[13] = 0x2A;
	msg[14] = 0x2A;
	
	ret = my_Serial_write(&com, (char*)&msg, 15);
	
	if (ret < 0 ) 
	{
		printf("ERROR : Serial io Char \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	if (ret == 0) 
	{
		printf("ERROR : Serial io Timeout \n");
		my_Serial_close(&com);
		exit(EXIT_FAILURE);
	}
	
	ret = pthread_create( &capture, NULL, &serial_capture, NULL);
	Fl::check();
}

void make_window() {
}
